#    Copyright 2013 - 2017 Mirantis, Inc.
#
#    Licensed under the Apache License, Version 2.0 (the "License"); you may
#    not use this file except in compliance with the License. You may obtain
#    a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#    License for the specific language governing permissions and limitations
#    under the License.

from __future__ import print_function

import argparse
import sys


def load_params():
    """
    Parse CLI arguments and environment variables

    Returns: ArgumentParser instance
    """

    parser = argparse.ArgumentParser(description=(
        '(NOT IMPLEMENTED) Run SI test scenarios\n\n'
    ), formatter_class=argparse.RawTextHelpFormatter)

    parser.add_argument('--verbose', dest='verbose',
                        action='store_const', const=True,
                        help='Show verbosed output', default=False)

    parser.add_argument('--config',
                        help='Config with extra options for test runner',
                        default='',
                        type=str)
    return parser


def main():
    args = sys.argv[1:]
    if len(args) == 0:
        args = ['-h']
    parser = load_params()
    opts = parser.parse_args(args)
    print(opts)


if __name__ == '__main__':
    sys.exit(main())
